#ifndef __JUCE_RSPLOTAXESSETUP_JUCEHEADER__
#define __JUCE_RSPLOTAXESSETUP_JUCEHEADER__

#include <juce.h>

class RSPlotAxesSetup	: public Component
{

public:

  RSPlotAxesSetup();
  /**< Constructor. */

  virtual ~RSPlotAxesSetup();
  /**< Destructor. */

  virtual void resized();
  /**< Overrides the resized()()-method of the Component base-class in order to arrange the widgets
  according to the size. */

  // the widgets are public in order to let the outlying 
  // RSPlotContentComponent listen to them and access them

  //-----------------------------------------------------------------------------------------------
  // widgets for controlling the axes:

  Label*            xAxisSetupLabel;
  Label*            xAnnotationLabel;
  Label*            xAnnotationEditLabel;
  Label*            xMinLabel;
  Label*            xMinEditLabel;
  Label*            xMaxLabel;
  Label*            xMaxEditLabel;
  Label*            xDigitsLabel;
  ComboBox*         xDigitsComboBox;
  Label*            xPosLabel;
  ComboBox*         xPosComboBox;
  ToggleButton*     xLogScaleButton;

  Label*            yAxisSetupLabel;
  Label*            yAnnotationLabel;
  Label*            yAnnotationEditLabel;
  Label*            yMinLabel;
  Label*            yMinEditLabel;
  Label*            yMaxLabel;
  Label*            yMaxEditLabel;
  Label*            yDigitsLabel;
  ComboBox*         yDigitsComboBox;
  Label*            yPosLabel;
  ComboBox*         yPosComboBox;
  ToggleButton*     yLogScaleButton;

  /*
  Label*            zAxisSetupLabel;
  Label*            zAnnotationLabel;
  Label*            zAnnotationEditLabel;
  Label*            zMinLabel;
  Label*            zMinEditLabel;
  Label*            zMaxLabel;
  Label*            zMaxEditLabel;
  ToggleButton*     zLogScaleButton;
  ComboBox*         zAxisComboBox;

  Label*            scaleSetupLabel;
  Label*            scaleLabelX;
  Slider*           scaleSliderX;
  Label*            scaleLabelY;
  Slider*           scaleSliderY;
  Label*            scaleLabelZ;
  Slider*           scaleSliderZ;
  */

  //-----------------------------------------------------------------------------------------------
  // widgets for controlling the grids in 2D coordinate-systems:

  Label*            gridSetupLabel;

  Label*            horizontalGridSetupLabel;
  ToggleButton*     horizontalCoarseGridButton;
  Label*            horizontalCoarseGridIntervalLabel;
  ToggleButton*     horizontalFineGridButton;
  Label*            horizontalFineGridIntervalLabel;

  Label*            verticalGridSetupLabel;
  ToggleButton*     verticalCoarseGridButton;
  Label*            verticalCoarseGridIntervalLabel;
  ToggleButton*     verticalFineGridButton;
  Label*            verticalFineGridIntervalLabel;

  Label*            radialGridSetupLabel;
  ToggleButton*     radialCoarseGridButton;
  Label*            radialCoarseGridIntervalLabel;
  ToggleButton*     radialFineGridButton;
  Label*            radialFineGridIntervalLabel;

  Label*            angularGridSetupLabel;
  ToggleButton*     angularCoarseGridButton;
  Label*            angularCoarseGridIntervalLabel;
  ToggleButton*     angularFineGridButton;
  Label*            angularFineGridIntervalLabel;

  //-----------------------------------------------------------------------------------------------
  // widgets for controlling the 3D parameters:

  /*
  Label*            rotationSetupLabel;
  Label*            rotationLabelX;
  Slider*           rotationSliderX;
  Label*            rotationLabelY;
  Slider*           rotationSliderY;
  Label*            rotationLabelZ;
  Slider*           rotationSliderZ;
  */
};

#endif	
