#include "RSPlotDataSetup.h"

RSPlotDataSetup::RSPlotDataSetup()
{
  typeOfDataLabel = new Label( String(T("typeOfDataLabel")), String(T("Type:")) );
  typeOfDataLabel->setJustificationType(Justification::centred);
  addAndMakeVisible( typeOfDataLabel );

  typeOfDataComboBox = new ComboBox(String(T("typeOfDataComboBox")));
  typeOfDataComboBox->addItem(String(T("Curve Family")),          1);
  typeOfDataComboBox->addItem(String(T("Surface Plot")),          2);
  typeOfDataComboBox->setItemEnabled(2, false);
  typeOfDataComboBox->setSelectedId(1);
  addAndMakeVisible( typeOfDataComboBox );

  dataSourceLabel = new Label( String(T("dataSourceLabel")), String(T("Source:")) );
  dataSourceLabel->setJustificationType(Justification::centred);
  addAndMakeVisible( dataSourceLabel );

  dataSourceComboBox = new ComboBox(String(T("dataSourceComboBox")));
  dataSourceComboBox->addItem(String(T("Expression")),            1);
  dataSourceComboBox->addItem(String(T("Data-File")),             2);
  dataSourceComboBox->setItemEnabled(2, false);
  dataSourceComboBox->setSelectedId(1);
  addAndMakeVisible( dataSourceComboBox );

  //-----------------------------------------------------------------------------------------------
  // widgets for entering the curve- and function-formulas:

  numCurvesLabel = new Label( String(T("numCurvesLabel")), String(T("Curves:")) );
  numCurvesLabel->setJustificationType(Justification::centredLeft);
  addAndMakeVisible( numCurvesLabel );

  numCurvesSlider = new Slider( String(T("numCurvesSlider")) );
  numCurvesSlider->setRange(1.0, 9.0, 1.0);
  numCurvesSlider->setValue(1.0);
  numCurvesSlider->setSliderStyle(Slider::LinearBar);
  addAndMakeVisible( numCurvesSlider );

  xCurveLabel = new Label( String(T("xCurveLabel")), String(T("x(t)=")) );
  xCurveLabel->setJustificationType(Justification::centredLeft);
  addAndMakeVisible( xCurveLabel );

  xCurveEditLabel = new Label( String(T("xCurveEditLabel")), String(T("t;")) );
  xCurveEditLabel->setJustificationType(Justification::centredLeft);
  xCurveEditLabel->setColour(Label::outlineColourId, Colours::black);
  xCurveEditLabel->setEditable(true, true);
  addAndMakeVisible( xCurveEditLabel );

  yCurveLabel = new Label( String(T("yCurveLabel")), String(T("y(x,t)=")) );
  yCurveLabel->setJustificationType(Justification::centredLeft);
  addAndMakeVisible( yCurveLabel );

  yCurveEditLabel = new Label( String(T("yCurveEditLabel")), String(T("x;")) );
  yCurveEditLabel->setJustificationType(Justification::centredLeft);
  yCurveEditLabel->setColour(Label::outlineColourId, Colours::black);
  yCurveEditLabel->setEditable(true, true);
  addAndMakeVisible( yCurveEditLabel );

  //-----------------------------------------------------------------------------------------------
  // widgets for the parameters a,b,c,d:

  aLabel = new Label( String(T("aLabel")), String(T("a:")) );
  aLabel->setJustificationType(Justification::centredLeft);
  addAndMakeVisible( aLabel );

  aMinEditLabel = new Label( String(T("aMinEditLabel")), String(T("0")) );
  aMinEditLabel->setJustificationType(Justification::centredLeft);
  aMinEditLabel->setColour(Label::outlineColourId, Colours::black);
  aMinEditLabel->setEditable(true, true);
  addAndMakeVisible( aMinEditLabel );

  aSlider = new Slider( String(T("aSlider")) );
  aSlider->setRange(0.0, 1.0, 0.0);
  aSlider->setValue(0.5);
  aSlider->setSliderStyle(Slider::LinearBar);
  addAndMakeVisible(aSlider);

  aMaxEditLabel = new Label( String(T("aMaxEditLabel")), String(T("1")) );
  aMaxEditLabel->setJustificationType(Justification::centredLeft);
  aMaxEditLabel->setColour(Label::outlineColourId, Colours::black);
  aMaxEditLabel->setEditable(true, true);
  addAndMakeVisible( aMaxEditLabel );

  bLabel = new Label( String(T("bLabel")), String(T("b:")) );
  bLabel->setJustificationType(Justification::centredLeft);
  addAndMakeVisible( bLabel );

  bMinEditLabel = new Label( String(T("bMinEditLabel")), String(T("0")) );
  bMinEditLabel->setJustificationType(Justification::centredLeft);
  bMinEditLabel->setColour(Label::outlineColourId, Colours::black);
  bMinEditLabel->setEditable(true, true);
  addAndMakeVisible( bMinEditLabel );

  bSlider = new Slider( String(T("bSlider")) );
  bSlider->setRange(0.0, 1.0, 0.0);
  bSlider->setValue(0.5);
  bSlider->setSliderStyle(Slider::LinearBar);
  addAndMakeVisible(bSlider);

  bMaxEditLabel = new Label( String(T("bMaxEditLabel")), String(T("1")) );
  bMaxEditLabel->setJustificationType(Justification::centredLeft);
  bMaxEditLabel->setColour(Label::outlineColourId, Colours::black);
  bMaxEditLabel->setEditable(true, true);
  addAndMakeVisible( bMaxEditLabel );

  cLabel = new Label( String(T("cLabel")), String(T("c:")) );
  cLabel->setJustificationType(Justification::centredLeft);
  addAndMakeVisible( cLabel );

  cMinEditLabel = new Label( String(T("cMinEditLabel")), String(T("0")) );
  cMinEditLabel->setJustificationType(Justification::centredLeft);
  cMinEditLabel->setColour(Label::outlineColourId, Colours::black);
  cMinEditLabel->setEditable(true, true);
  addAndMakeVisible( cMinEditLabel );

  cSlider = new Slider( String(T("cSlider")) );
  cSlider->setRange(0.0, 1.0, 0.0);
  cSlider->setValue(0.5);
  cSlider->setSliderStyle(Slider::LinearBar);
  addAndMakeVisible(cSlider);

  cMaxEditLabel = new Label( String(T("cMaxEditLabel")), String(T("1")) );
  cMaxEditLabel->setJustificationType(Justification::centredLeft);
  cMaxEditLabel->setColour(Label::outlineColourId, Colours::black);
  cMaxEditLabel->setEditable(true, true);
  addAndMakeVisible( cMaxEditLabel );

  dLabel = new Label( String(T("dLabel")), String(T("d:")) );
  dLabel->setJustificationType(Justification::centredLeft);
  addAndMakeVisible( dLabel );

  dMinEditLabel = new Label( String(T("dMinEditLabel")), String(T("0")) );
  dMinEditLabel->setJustificationType(Justification::centredLeft);
  dMinEditLabel->setColour(Label::outlineColourId, Colours::black);
  dMinEditLabel->setEditable(true, true);
  addAndMakeVisible( dMinEditLabel );

  dSlider = new Slider( String(T("dSlider")) );
  dSlider->setRange(0.0, 1.0, 0.0);
  dSlider->setValue(0.5);
  dSlider->setSliderStyle(Slider::LinearBar);
  addAndMakeVisible(dSlider);

  dMaxEditLabel = new Label( String(T("dMaxEditLabel")), String(T("1")) );
  dMaxEditLabel->setJustificationType(Justification::centredLeft);
  dMaxEditLabel->setColour(Label::outlineColourId, Colours::black);
  dMaxEditLabel->setEditable(true, true);
  addAndMakeVisible( dMaxEditLabel );

  //-----------------------------------------------------------------------------------------------
  // widgets for defining the sampling of the t-parameter for the curve or function:

  samplingLabel = new Label( String(T("samplingLabel")), String(T("Sampling:")) );
  samplingLabel->setJustificationType(Justification::centredLeft);
  addAndMakeVisible( samplingLabel );

  tMinLabel = new Label( String(T("tMinLabel")), String(T("Min:")) );
  tMinLabel->setJustificationType(Justification::centredLeft);
  addAndMakeVisible( tMinLabel );

  tMinEditLabel = new Label( String(T("tMinEditLabel")), String(T("0")) );
  tMinEditLabel->setJustificationType(Justification::centredLeft);
  tMinEditLabel->setColour(Label::outlineColourId, Colours::black);
  tMinEditLabel->setEditable(true, true);
  addAndMakeVisible( tMinEditLabel );

  tMaxLabel = new Label( String(T("tMaxLabel")), String(T("Max:")) );
  tMaxLabel->setJustificationType(Justification::centredLeft);
  addAndMakeVisible( tMaxLabel );

  tMaxEditLabel = new Label( String(T("tMaxEditLabel1")), String(T("10")) );
  tMaxEditLabel->setJustificationType(Justification::centredLeft);
  tMaxEditLabel->setColour(Label::outlineColourId, Colours::black);
  tMaxEditLabel->setEditable(true, true);
  addAndMakeVisible( tMaxEditLabel );

  numSamplesLabel = new Label( String(T("NumSamplesLabel")), String(T("Samples:")) );
  numSamplesLabel->setJustificationType(Justification::centredLeft);
  addAndMakeVisible( numSamplesLabel );

  numSamplesSlider = new Slider( String(T("numSamplesSlider")) );
  numSamplesSlider->setRange(16.0, 1024.0, 1.0);
  numSamplesSlider->setValue(100.0);
  numSamplesSlider->setSliderStyle(Slider::LinearBar);
  addAndMakeVisible(numSamplesSlider);

  tExponentialSpacingButton = new ToggleButton(String("exp-spacing"));
  tExponentialSpacingButton->setClickingTogglesState(true);
  tExponentialSpacingButton->setToggleState(false, true);
  addAndMakeVisible(tExponentialSpacingButton);

  //-----------------------------------------------------------------------------------------------
  // widgets for the quick-calculator:

  quickCalcLabel = new Label( String(T("quickCalcLabel")), String(T("Calc: t=")) );
  quickCalcLabel->setJustificationType(Justification::centredLeft);
  quickCalcLabel->setEditable(false, false);
  addAndMakeVisible( quickCalcLabel );

  quickCalcInputLabel = new Label( String(T("quickCalcInputLabel")), String(T("1")) );
  quickCalcInputLabel->setJustificationType(Justification::centredLeft);
  quickCalcInputLabel->setColour(Label::outlineColourId, Colours::black);
  quickCalcInputLabel->setEditable(true, true);
  addAndMakeVisible( quickCalcInputLabel );

  quickCalcOutputLabelX = new Label( String(T("quickCalcOutputLabel")), String(T("x=1")) );
  quickCalcOutputLabelX->setJustificationType(Justification::centredLeft);
  quickCalcOutputLabelX->setColour(Label::outlineColourId, Colours::black);
  quickCalcOutputLabelX->setEditable(true, true);
  addAndMakeVisible( quickCalcOutputLabelX );

  quickCalcOutputLabelY = new Label( String(T("quickCalcOutputLabel")), String(T("y=1")) );
  quickCalcOutputLabelY->setJustificationType(Justification::centredLeft);
  quickCalcOutputLabelY->setColour(Label::outlineColourId, Colours::black);
  quickCalcOutputLabelY->setEditable(true, true);
  addAndMakeVisible( quickCalcOutputLabelY );

  //-----------------------------------------------------------------------------------------------
  // widgets for the data import:

  fileLabel = new Label( String(T("fileLabel")), String(T("Data-File:")) );
  fileLabel->setJustificationType(Justification::centredLeft);
  addChildComponent(fileLabel);

  fileNameLabel = new Label( String(T("fileLabel")), String(T("none loaded")) );
  fileNameLabel->setJustificationType(Justification::centredLeft);
  fileNameLabel->setColour(Label::outlineColourId, Colours::black);
  addChildComponent(fileNameLabel);

  loadButton = new TextButton(String(T("Load")), String(T("Load data from a file.")));
  addChildComponent(loadButton);
}

RSPlotDataSetup::~RSPlotDataSetup()
{
  deleteAllChildren();
}

void RSPlotDataSetup::setMinMaxA(double newMin, double newMax)
{
  if( newMin < newMax )
  {
    aMinEditLabel->setText(String(newMin), false);
    aMaxEditLabel->setText(String(newMax), false);
    aSlider->setRange(newMin, newMax);
  }
}

void RSPlotDataSetup::setMinMaxB(double newMin, double newMax)
{
  if( newMin < newMax )
  {
    bMinEditLabel->setText(String(newMin), false);
    bMaxEditLabel->setText(String(newMax), false);
    bSlider->setRange(newMin, newMax);
  }
}

void RSPlotDataSetup::setMinMaxC(double newMin, double newMax)
{
  if( newMin < newMax )
  {
    cMinEditLabel->setText(String(newMin), false);
    cMaxEditLabel->setText(String(newMax), false);
    cSlider->setRange(newMin, newMax);
  }
}

void RSPlotDataSetup::setMinMaxD(double newMin, double newMax)
{
  if( newMin < newMax )
  {
    dMinEditLabel->setText(String(newMin), false);
    dMaxEditLabel->setText(String(newMax), false);
    dSlider->setRange(newMin, newMax);
  }
}

void RSPlotDataSetup::setMinMaxT(double newMin, double newMax)
{
  if( newMin < newMax )
  {
    tMinEditLabel->setText(String(newMin), false);
    tMaxEditLabel->setText(String(newMax), false);
  }
}

//-------------------------------------------------------------------------------------------------
// appearance:

void RSPlotDataSetup::resized()
{
  Component::resized();

  int xL, xR, yT, yB; // left, right, top and bottom for the child-component
  int w, h;           // width and height for the child component

  xL = 0;
  xR = getWidth();
  w  = (xR-xL)/3;
  yT = 4;
  yB = getHeight();
  h  = yB-yT;

  dataSourceLabel->setBounds(xL+4, yT, 56, 20);
  dataSourceComboBox->setBounds(xL+56+4, yT, w-56-8, 20);
  xL += w;
  typeOfDataLabel->setBounds(xL+4, yT, 56, 20);
  typeOfDataComboBox->setBounds(xL+56+4, yT, w-56-8, 20);
  xL += w;
  numCurvesLabel->setBounds(xL+4, yT, 56, 20);
  numCurvesSlider->setBounds(xL+56+4, yT, w-56-8, 20);

  xL  = 0;
  w   = getWidth();
  yT += 24;

  xCurveLabel->setBounds(xL+4, yT, 56, 20);
  xCurveEditLabel->setBounds(xL+56+4, yT, w-56-8, 20);
  yT += 24;
  yCurveLabel->setBounds(xL+4, yT, 56, 20);
  yCurveEditLabel->setBounds(xL+56+4, yT, w-56-8, 20);


  w   = getWidth()/4;
  yT += 24;

  aLabel->setBounds(xL+4, yT, 20, 20);
  aMinEditLabel->setBounds(xL+20+4, yT, 32, 20);
  aMaxEditLabel->setBounds(xL+w-32-8, yT, 32, 20);
  aSlider->setBounds(aMinEditLabel->getRight(), yT, 
                     aMaxEditLabel->getX()-aMinEditLabel->getRight(), 20);
  yT += 24;
  bLabel->setBounds(xL+4, yT, 20, 20);
  bMinEditLabel->setBounds(xL+20+4, yT, 32, 20);
  bMaxEditLabel->setBounds(xL+w-32-8, yT, 32, 20);
  bSlider->setBounds(bMinEditLabel->getRight(), yT, 
                     bMaxEditLabel->getX()-bMinEditLabel->getRight(), 20);

  yT  = aLabel->getY();
  xL += w;
  cLabel->setBounds(xL+4, yT, 20, 20);
  cMinEditLabel->setBounds(xL+20+4, yT, 32, 20);
  cMaxEditLabel->setBounds(xL+w-32-8, yT, 32, 20);
  cSlider->setBounds(cMinEditLabel->getRight(), yT, 
                     cMaxEditLabel->getX()-cMinEditLabel->getRight(), 20);
  yT += 24;
  dLabel->setBounds(xL+4, yT, 20, 20);
  dMinEditLabel->setBounds(xL+20+4, yT, 32, 20);
  dMaxEditLabel->setBounds(xL+w-32-8, yT, 32, 20);
  dSlider->setBounds(dMinEditLabel->getRight(), yT, 
                     dMaxEditLabel->getX()-dMinEditLabel->getRight(), 20);

  yT  = aLabel->getY();
  xL += w;

  samplingLabel->setBounds(xL, yT, w, 20);
  tExponentialSpacingButton->setBounds(xL+w-88, yT, 88-8, 20);
  yT += 24;

  tMinEditLabel->setBounds(xL+4, yT, 32, 20);
  tMaxEditLabel->setBounds(xL+w-32-8, yT, 32, 20);
  numSamplesSlider->setBounds(tMinEditLabel->getRight(), yT, 
                              tMaxEditLabel->getX()-tMinEditLabel->getRight(), 20);

  yT  = aLabel->getY();
  xL += w;
  quickCalcLabel->setBounds(xL+4, yT, 56, 20);
  quickCalcInputLabel->setBounds(quickCalcLabel->getRight(), yT, w-56-8, 20);
  yT += 24;
  quickCalcOutputLabelX->setBounds(xL+4, yT, w/2-4, 20);
  xL += w/2-4;
  quickCalcOutputLabelY->setBounds(xL+4, yT, w/2-4, 20);

  yT = numCurvesLabel->getBottom();
  yT += 32;
  fileLabel->setBounds(xL, yT, 80, 20);
  loadButton->setBounds(xR-60, yT-2, 56, 24);
  yT += 24;
  fileNameLabel->setBounds(xL+4, yT, w-4, 20);

}

