#include "RSPlotFileSetup.h"

RSPlotFileSetup::RSPlotFileSetup()
{

  fileNameLabel = new Label( String(T("FileName")), String::empty );
  fileNameLabel->setJustificationType(Justification::centredLeft);
  fileNameLabel->setColour(Label::backgroundColourId, Colours::white);
  fileNameLabel->setColour(Label::outlineColourId, Colours::black);
  addAndMakeVisible( fileNameLabel );

  loadButton = new ToggleButton(String(T("Load")) );
  loadButton->setClickingTogglesState(false);
  addAndMakeVisible(loadButton);

  saveButton = new ToggleButton(String(T("Save")) );
  saveButton->setClickingTogglesState(false);
  addAndMakeVisible(saveButton);

  plusButton = new SymbolButton(SymbolButton::PLUS);
  plusButton->setClickingTogglesState(false);
  addAndMakeVisible(plusButton);

  minusButton = new SymbolButton(SymbolButton::MINUS);
  minusButton->setClickingTogglesState(false);
  addAndMakeVisible(minusButton);


  imageExportLabel = new Label( String(T("imageExportLabel")), String(T("Export:")) );
  imageExportLabel->setJustificationType(Justification::centredLeft);
  addAndMakeVisible( imageExportLabel );

  imageWidthLabel = new Label( String(T("ImageWidth")), String(T("W:")) );
  imageWidthLabel->setJustificationType(Justification::centredLeft);
  addAndMakeVisible( imageWidthLabel );

  imageWidthEditLabel = new Label( String(T("ImageWidthEditLabel")), String(T("320")) );
  imageWidthEditLabel->setJustificationType(Justification::centredLeft);
  imageWidthEditLabel->setColour(Label::outlineColourId, Colours::black);
  imageWidthEditLabel->setColour(Label::backgroundColourId, Colours::white);
  imageWidthEditLabel->setEditable(true, true);
  addAndMakeVisible( imageWidthEditLabel );

  imageHeightLabel = new Label( String(T("ImageHeight")), String(T("H:")) );
  imageHeightLabel->setJustificationType(Justification::centredLeft);
  addAndMakeVisible( imageHeightLabel );

  imageHeightEditLabel = new Label( String(T("ImageHeightEditLabel")), String(T("320")) );
  imageHeightEditLabel->setJustificationType(Justification::centredLeft);
  imageHeightEditLabel->setColour(Label::outlineColourId, Colours::black);
  imageHeightEditLabel->setColour(Label::backgroundColourId, Colours::white);
  imageHeightEditLabel->setEditable(true, true);
  addAndMakeVisible( imageHeightEditLabel );

  pngExportButton = new ToggleButton(String(T("PNG")));
  pngExportButton->setClickingTogglesState(false);
  addAndMakeVisible(pngExportButton);

  svgExportButton = new ToggleButton(String(T("SVG")));
  svgExportButton->setClickingTogglesState(false);
  addAndMakeVisible(svgExportButton);
}

RSPlotFileSetup::~RSPlotFileSetup()
{
  deleteAllChildren();
}

//-------------------------------------------------------------------------------------------------
// appearance:

void RSPlotFileSetup::resized()
{
  Component::resized();

  int x = 0;
  int w = getWidth();
  int y = 0;
  int h = getHeight();

  fileNameLabel->setBounds(x+4, y+4, w-8, 20);
  y += 24;

  saveButton->setBounds(x+4, y+4, 40, 16); 
  x += 44;
  loadButton->setBounds(x+4, y+4, 40, 16);
  x += 44;
  minusButton->setBounds(x+4, y+4, 16, 16);
  x += 16;
  plusButton->setBounds(x+4, y+4, 16, 16);

  x  = 0;
  y += 28;
  imageExportLabel->setBounds(x+4, y+4, 52, 16);
  x += 52;
  pngExportButton->setBounds(x+4,  y+4, 32, 16);
  x += 32+4;
  svgExportButton->setBounds(x+4,  y+4, 32, 16);

  x  = 0;
  y += 24;
  imageWidthLabel->setBounds(x, y, 24, 16);
  imageWidthEditLabel->setBounds(x+24, y, w/2-24-4, 16);
  x += w/2;
  imageHeightLabel->setBounds(x, y, 24, 16);
  imageHeightEditLabel->setBounds(x+24, y, w/2-24-4, 16);
}
