/**

This class represents the visible range for a CoordinateSystem3D (and is used 
inside this class).

*/

#ifndef __JUCE_COORDINATESYSTEM3DRANGE_JUCEHEADER__
#define __JUCE_COORDINATESYSTEM3DRANGE_JUCEHEADER__

#include "CoordinateSystemRange.h"

class CoordinateSystem3DRange : public CoordinateSystemRange
{

public:

 /** Standard Constructor. */
 CoordinateSystem3DRange(double initMinX = -2.2, double initMaxX = +2.2,
                         double initMinY = -2.2, double initMaxY = +2.2,
                         double initMinZ = -2.2, double initMaxZ = +2.2);

 /** Destructor. */
 virtual ~CoordinateSystem3DRange();  

 /** Returns the minimum z-value. */
 virtual double getMinZ() const { return minZ; }

 /** Returns the maximum z-value. */
 virtual double getMaxZ() const { return maxZ; }

 /** Sets the minimum z-value. */
 virtual void setMinZ(double newMinZ);

 /** Sets the maximum z-value. */
 virtual void setMaxZ(double newMaxZ); 

protected:

 double minZ, maxZ;
};

#endif  // __JUCE_COORDINATESYSTEM3DRANGE_JUCEHEADER__
