#include "CoordinateSystemRange.h"

CoordinateSystemRange::CoordinateSystemRange(double initMinX, double initMaxX,
                                             double initMinY, double initMaxY)
{
  minX = initMinX;
  maxX = initMaxX;
  minY = initMinY;
  maxY = initMaxY;
}

CoordinateSystemRange::~CoordinateSystemRange()
{

}

void CoordinateSystemRange::setMinX(double newMinX) 
{ 
  jassert( newMinX < maxX )
    if( newMinX < maxX )
      minX = newMinX;
}

void CoordinateSystemRange::setMaxX(double newMaxX) 
{ 
  jassert( newMaxX > minX )
    if( newMaxX > minX )
      maxX = newMaxX;
}

void CoordinateSystemRange::setRangeX(double newMinX, double newMaxX)
{
  jassert( newMaxX > newMinX )
    if( newMaxX > newMinX )
    {
      minX = newMinX;
      maxX = newMaxX;
    }
}

void CoordinateSystemRange::setMinY(double newMinY) 
{ 
  jassert( newMinY < maxY )
    if( newMinY < maxY )
      minY = newMinY;
}

void CoordinateSystemRange::setMaxY(double newMaxY) 
{ 
  jassert( newMaxY > minY )
    if( newMaxY > minY )
      maxY = newMaxY;
}

void CoordinateSystemRange::setRangeY(double newMinY, double newMaxY)
{
  jassert( newMaxY > newMinY )
    if( newMaxY > newMinY )
    {
      minY = newMinY;
      maxY = newMaxY;
    }
}

void CoordinateSystemRange::clipRange(CoordinateSystemRange rangeToClipTo)
{
  if( minX < rangeToClipTo.getMinX() )
    minX = rangeToClipTo.getMinX();
  if( maxX > rangeToClipTo.getMaxX() )
    maxX = rangeToClipTo.getMaxX();
  if( minY < rangeToClipTo.getMinY() )
    minY = rangeToClipTo.getMinY();
  if( maxY > rangeToClipTo.getMaxY() )
    maxY = rangeToClipTo.getMaxY();
}


