#include "MetallicLookAndFeel.h"

MetallicLookAndFeel::MetallicLookAndFeel() : LookAndFeel()
{
 /*
 topLeftWhiteValue     = 1.0f;
 topRightWhiteValue    = 0.7f;
 bottomLeftWhiteValue  = 0.7f;
 bottomRightWhiteValue = 0.4f;
 */
}

MetallicLookAndFeel::~MetallicLookAndFeel()
{

}

/*
Button* MetallicLookAndFeel::createDocumentWindowButton (int buttonType)
{
    Path shape;
    const float crossThickness = 1.0f;

    if (buttonType == DocumentWindow::closeButton)
    {
        shape.addLineSegment (0.0f, 0.0f, 1.0f, 1.0f, crossThickness * 1.0f);
        shape.addLineSegment (1.0f, 0.0f, 0.0f, 1.0f, crossThickness * 1.0f);

        //return new MetalWindowButton (T("close"), Colours::black, shape, shape);
        return new MetallicCloseButton (T("close"));
    }
    else if (buttonType == DocumentWindow::minimiseButton)
    {
        shape.addLineSegment (0.0f, 0.5f, 1.0f, 0.5f, crossThickness);

        return new MetallicMinimiseButton(T("minimise"));
    }
    else if (buttonType == DocumentWindow::maximiseButton)
    {
        shape.addLineSegment (0.5f, 0.0f, 0.5f, 1.0f, crossThickness);
        shape.addLineSegment (0.0f, 0.5f, 1.0f, 0.5f, crossThickness);

        Path fullscreenShape;
        fullscreenShape.startNewSubPath (45.0f, 100.0f);
        fullscreenShape.lineTo (0.0f, 100.0f);
        fullscreenShape.lineTo (0.0f, 0.0f);
        fullscreenShape.lineTo (100.0f, 0.0f);
        fullscreenShape.lineTo (100.0f, 45.0f);
        fullscreenShape.addRectangle (45.0f, 45.0f, 100.0f, 100.0f);
        PathStrokeType (30.0f).createStrokedPath (fullscreenShape, fullscreenShape);

        return new MetallicMaximiseButton (T("maximise"));
    }

    jassertfalse
    return 0;
}
*/

/*
void MetallicLookAndFeel::drawComboBox (Graphics& g, int width, int height,
                                        const bool isButtonDown,
                                        int buttonX, int buttonY,
                                        int buttonW, int buttonH,
                                        ComboBox& box)
{
 g.fillAll(Colours::white);

    if (box.isEnabled() && box.hasKeyboardFocus (false))
    {
     g.setColour (Colours::lightsteelblue);
     g.drawRect (0, 0, width, height, 2);
    }
    else
    {
     g.setColour (Colours::black);
     g.drawRect (0, 0, width, height);
    }

    const float outlineThickness = box.isEnabled() ? (isButtonDown ? 1.2f : 0.5f) : 0.3f;

    const Colour baseColour(Colours::lightgrey);

    drawGlassLozenge (g,
                      buttonX + outlineThickness, buttonY + outlineThickness,
                      buttonW - outlineThickness * 2.0f, buttonH - outlineThickness * 2.0f,
                      baseColour, outlineThickness, -1.0f,
                      true, true, true, true);
    // commented for dabbling between JUCE 1.43 and 1.44 re-activate this later

    if (box.isEnabled())
    {
        const float arrowX = 0.3f;
        const float arrowH = 0.2f;

        Path p;
        p.addTriangle (buttonX + buttonW * 0.5f,            buttonY + buttonH * (0.45f - arrowH),
                       buttonX + buttonW * (1.0f - arrowX), buttonY + buttonH * 0.45f,
                       buttonX + buttonW * arrowX,          buttonY + buttonH * 0.45f);

        p.addTriangle (buttonX + buttonW * 0.5f,            buttonY + buttonH * (0.55f + arrowH),
                       buttonX + buttonW * (1.0f - arrowX), buttonY + buttonH * 0.55f,
                       buttonX + buttonW * arrowX,          buttonY + buttonH * 0.55f);

        g.setColour (Colours::black.withAlpha (0.6f));
        g.fillPath (p);
    }
}
*/


void MetallicLookAndFeel::drawLinearSlider (Graphics& g,
                                            int x, int y,
                                            int width, int height,
                                            float sliderPos,
                                            float minSliderPos,
                                            float maxSliderPos,
                                            const Slider::SliderStyle style,
                                            Slider& slider) 

{
 // test, if the pointer to the slider can be catsed to a pointer
 // to a SliderWithoutBoxes:
 if( !dynamic_cast<SliderWithoutBoxes *>(&slider) )
 {
  LookAndFeel::drawLinearSlider(g,
                                x, y,
                                width, height,
                                sliderPos,
                                minSliderPos,
                                maxSliderPos,
                                style,
                                slider);
  return;
 }

 // do the type-cast of the pointer:
 SliderWithoutBoxes* pFader = (SliderWithoutBoxes*) &slider;

 // get the width and height of the faders client area:
 int w          = pFader->getWidth();
 int h          = pFader->getHeight();
 int faderBodyW = w;
 int faderBodyH = faderBodyW/2;

 // get the current fader-position between 0...1:
 float proportion = (float) pFader->valueToProportionOfLength(pFader->getValue());

 if( style == Slider::LinearVertical )
 {
  int lowPosition  = h - faderBodyH;
  int highPosition = 0;

  int faderBodyX = 0 + (width - faderBodyW)/2;
  int faderBodyY = (int) ( lowPosition - proportion*(lowPosition-highPosition) );

  // draw the vertical line on which the fader slides along:
  g.setColour(Colours::black);
  g.drawLine(float(faderBodyX+faderBodyW/2), float(lowPosition+faderBodyH/2), 
             float(faderBodyX+faderBodyW/2), float(highPosition+faderBodyH/2), 1.0f);

  // draw some horizontal lines to divide the range:
  int   i            = 0;
  int   numDivisions = 10;
  float lineOffset   = ((lowPosition+faderBodyH/2)-(highPosition+faderBodyH/2)) / (float) numDivisions;
  int   xStart       = (width-faderBodyW)/2 + 4;
  int   xEnd         = xStart+faderBodyW    - 8;
  float yPos;
  for(i=0; i<=numDivisions; i++)
  {
   yPos = highPosition+faderBodyH/2 + i*lineOffset;
   g.drawLine( (float) xStart, (float) yPos, (float) xEnd, (float) yPos, 1.0f);
  }

  ColourGradient grad(Colours::white, 
                     (float) faderBodyX,    
                     (float) faderBodyY,
                     Colours::grey,  
                     (float) (faderBodyX+faderBodyW), 
                     (float) (faderBodyY+faderBodyH),
                     false);

  GradientBrush gradBrush(grad);

  g.setBrush(&gradBrush);

  g.fillRect(faderBodyX, faderBodyY, faderBodyW, faderBodyH);

  g.drawBevel(faderBodyX, faderBodyY, faderBodyW, faderBodyH, 4, 
              Colour((uint8)250,(uint8)250,(uint8)250,(uint8)150),
              Colour((uint8)50,(uint8)50,(uint8)50,(uint8)150),
              true);

  g.setColour(juce::Colours::black);
  g.drawRect(faderBodyX, faderBodyY, 
             faderBodyW, faderBodyH, 1);
 }
 else if( style == Slider::LinearHorizontal )
 {

 }

}

void MetallicLookAndFeel::drawRotarySlider(Graphics&   g, 
                                            int         x, 
                                            int         y, 
                                            int         width, 
                                            int         height, 
                                            float       sliderPos, 
                                            const float rotaryStartAngle, 
                                            const float rotaryEndAngle, 
                                            Slider&     slider)
{
 // check if the slider is of class "KnobWithoutBoxes" (using RunTime Type 
 // Identification, RTTI) - if not, call the drawRotarySlider()-method 
 // of the ShinyLookAndFeel base class and leave this function. this is 
 // necessarry, because this method will make use of some member-functions
 // of the "BraindocsKnob" class which are not present in its the "Slider"
 // base class:

 if( dynamic_cast<SliderWithoutBoxes *>(&slider) )
 {
  // do the type-cast of the pointer:
  SliderWithoutBoxes* pSlider = (SliderWithoutBoxes*) &slider;

  // the compact form with the drag-arrows is subsumed under the rotary knob
  // slider style but must be drawn differently:
  if( pSlider->isUpDownDragger ) 
  {
   float centreX      = (float) (width - 4.5);
   float centreY      = (float) (0.5 * height);
   float arrowLength  = (float) (0.5 * height - 2.0);

   // the down-arrow:
   g.drawArrow(centreX, centreY,   centreX, centreY+arrowLength, 0.0, 7.0, 5.0);

   // the up-arrow:
   g.drawArrow(centreX, centreY,   centreX, centreY-arrowLength, 0.0, 7.0, 5.0);

   // an enclosing rectangle:
   g.drawRect(x, y, width, height, 1);
  }
  else  // draw normal rotary knob:
  {

   const float w = (float) slider.getWidth();
   const float h = (float) slider.getHeight();

   const float radius  = 0.5f*w;
   const float centreX = 0.5f*w;
   const float centreY = 0.5f*h;

   const float rx = centreX - radius;
   const float ry = centreY - radius;
   const float rw = radius * 2.0f;
   const float angle = rotaryStartAngle + sliderPos * (rotaryEndAngle - rotaryStartAngle);
   const bool  isMouseOver = slider.isMouseOverOrDragging() && slider.isEnabled();

   // what's this ?:
   if (slider.isEnabled())
    g.setColour (Colours::blue.withAlpha (isMouseOver ? 0.5f : 0.35f));
   else
    g.setColour (Colours::grey.withAlpha (0.5f));

   const float thickness = 0.7f; // is this actually used?

   g.setColour(Colours::grey);
   g.fillEllipse(rx, ry, rw, rw);

   ColourGradient grad;

   grad = ColourGradient(Colour((uint8)255,(uint8)255,(uint8)255,(uint8)255), rx,    ry, 
                        Colour((uint8)100,(uint8)100,(uint8)100,(uint8)255), rx+rw, ry+rw, false);

   GradientBrush  gBrush(grad); 
   g.setBrush(&gBrush);
   g.fillEllipse(rx+1, ry+1, rw-2, rw-2);

   grad = ColourGradient(Colour((uint8)200,(uint8)200,(uint8)200,(uint8)200), 
                         rx,    rw, 
                         Colour((uint8)200,(uint8)200,(uint8)200,(uint8)200), 
                         rw ,   ry, false);
   grad.addColour(0.5, Colour((uint8)255,(uint8)255,(uint8)255,(uint8)200) );
   GradientBrush  gBrush2(grad);

   g.setBrush(&gBrush2);
   g.fillEllipse(rx+4, ry+4, rw-8, rw-8);

   // position for the line from center to periphery:
   float xPos = centreX + sinf(angle)*radius;
   float yPos = centreY - cosf(angle)*radius;

   // draw the line from the center to the periphery:
   g.setColour(Colours::black);
   g.drawLine(centreX, centreY, xPos, yPos, 2.0);
  }
 }
 else // slider could not be casted to one of my proprietary subclasses, use
      // the standard drawing form the base class therefore
 {
  LookAndFeel::drawRotarySlider(g, x, y, width, height, sliderPos,
                                rotaryStartAngle, rotaryEndAngle, slider);
 }

}

void MetallicLookAndFeel::drawToggleButton(juce::Graphics &g,
                                            juce::ToggleButton &button,
                                            bool isMouseOverButton,
                                            bool isButtonDown)
{
 int w = button.getWidth();
 int h = button.getHeight();

 ColourGradient grad;

 if(button.getToggleState() || button.isDown())
 {
  g.drawBevel(0, 0, w, h, 4, 
              Colour((uint8)40,(uint8)40,(uint8)40,(uint8)255),
              Colour((uint8)80,(uint8)80,(uint8)80,(uint8)255),
              true);

  grad = ColourGradient(Colour((uint8)220,(uint8)220,(uint8)220,(uint8)150), 
                        0.0f,      0.0f, 
                        Colour((uint8)120,(uint8)120,(uint8)120,(uint8)150), 
                        (float) w, (float) h, false);
 }
 else
 {
  g.drawBevel(0, 0, w, h, 4, 
              Colour((uint8)255,(uint8)255,(uint8)255,(uint8)255),
              Colour((uint8)50,(uint8)50,(uint8)50,(uint8)255),
              true);

 grad = ColourGradient(Colour((uint8)255,(uint8)255,(uint8)255,(uint8)150), 
                       0.0f,      0.0f, 
                       Colour((uint8)150,(uint8)150,(uint8)150,(uint8)150), 
                       (float) w, (float) h, false);
 }

 //grad.addColour(0.5, Colour((uint8)255,(uint8)255,(uint8)255,(uint8)150) );
 GradientBrush  gBrush(grad);

 g.setBrush(&gBrush);
 g.fillRect(4, 4, w-8, h-8);

 g.setColour(juce::Colours::black);
 g.drawRect(0, 0, w, h, 1);

 /*
 Font myFont;
 myFont.setTypefaceName(String(T("Courier New")));
 myFont.setHeight(16);
 myFont.setBold(true);
 myFont.setItalic(false);
 g.setFont(myFont);
 */

 g.drawText(button.getName(), 4, 4, w-8, h-8, 
            juce::Justification::centred, false);
}



//----------------------------------------------------------------------------
//

void MetallicLookAndFeel::setWhiteValues(float newTopLeftWhiteValue, 
                                         float newTopRightWhiteValue, 
                                         float newBottomLeftWhiteValue, 
                                         float newBottomRightWhiteValue)
{
 /*
 if( newTopLeftWhiteValue >= 0.0f && newTopLeftWhiteValue <= 1.0f )
  topLeftWhiteValue = newTopLeftWhiteValue;
 if( newTopRightWhiteValue >= 0.0f && newTopRightWhiteValue <= 1.0f )
  topRightWhiteValue = newTopRightWhiteValue;
 if( newBottomLeftWhiteValue >= 0.0f && newBottomLeftWhiteValue <= 1.0f )
  bottomLeftWhiteValue = newBottomLeftWhiteValue;
 if( newBottomRightWhiteValue >= 0.0f && newBottomRightWhiteValue <= 1.0f )
  bottomRightWhiteValue = newBottomRightWhiteValue;
 */
}

void MetallicLookAndFeel::fillRectWithMetallicGradient(juce::Graphics &g, 
                                                       int x, 
                                                       int y, 
                                                       int w, 
                                                       int h)
{
 // allocate an empty image-object: 
 Image *background = new Image(juce::Image::RGB, w, h, false);

 // allocate memory for the raw pixel-data (h lines, each line has w colums, 
 // each pixel has 3 bytes for blue, green and red (in that order)):
 uint8 *pixelData  = new uint8[h*w*3];

 int    baseAddress;    
  // address for a blue-value (is followed by addresses for green and red)

 int    baseAddressInc = 3*w; 
  // increment for the baseAddress per iteration of the inner loop 

 // declare some variables:
 float topLeft     = 1.0f;   // white-value for the top-left corner
 float topRight    = 0.75f;  // white-value for the top-right corner
 float bottomLeft  = 0.75f;  // white-value for the bottom-left corner
 float bottomRight = 0.5f;   // white-value for the bottom-right corner
 float top, bottom;  // for the white-values in the top- and bottom line
 //float here;         // for the white-value at the current pixel
 float p = 0.0;      // current relative x-position (from 0.0...1.0, depends on i)
 float q = 0.0;      // current relative y-position (from 0.0...1.0, depends on j)
 float pInc = 1.0f/(float)(w-1); // increment per iteration for p
 float qInc = 1.0f/(float)(h-1); // increment per (inner) iteration for q
 float pixelWhiteValueFlt; // for the white-value at the current pixel
 uint8 pixelWhiteValueInt; // the same, but converted to uint8

 for(int i=0; i<w; i++)
 {
  top    = (1-p)*topLeft    + p*topRight;    // white-value of one pixel in the top-line
  bottom = (1-p)*bottomLeft + p*bottomRight; // white-value of one pixel in the bottom-line

  // draw the current top-line pixel:
  pixelWhiteValueInt = (uint8) (255 * top);
  baseAddress = 3*i;
  pixelData[baseAddress+0] = pixelWhiteValueInt;  // the blue-value
  pixelData[baseAddress+1] = pixelWhiteValueInt;  // the green-value
  pixelData[baseAddress+2] = pixelWhiteValueInt;  // the red-value

  // draw the current bottom-line pixel:
  pixelWhiteValueInt = (uint8) (255 * bottom);
  baseAddress = 3*i+w*(h-1)*3;
  pixelData[baseAddress+0] = pixelWhiteValueInt;  // the blue-value
  pixelData[baseAddress+1] = pixelWhiteValueInt;  // the green-value
  pixelData[baseAddress+2] = pixelWhiteValueInt;  // the red-value

  p += pInc; // increment the relative x-position:

  // fill the column between 'top' and 'bottom':
  baseAddress = 3*i;
  q = 0.0;
  for(int j=1; j<(h-1); j++) 
  {
   pixelWhiteValueFlt = (1-q)*top + q*bottom;   // white-value for the pixel here
   pixelWhiteValueInt = (uint8) (255 * pixelWhiteValueFlt);

   baseAddress += baseAddressInc;

   pixelData[baseAddress+0] = pixelWhiteValueInt;  // the blue-value
   pixelData[baseAddress+1] = pixelWhiteValueInt;  // the green-value
   pixelData[baseAddress+2] = pixelWhiteValueInt;  // the red-value

   q += qInc; // increment the relative y-position:
  }
 }

 // copy the generated pixel-data into the image-object:
 background->setPixelData(0, 0, w, h, pixelData, 3*w);

 // draw the image into the graphics-object:
 //g.drawImage(background, 0, 0, w, h, 0, 0, w, h);
 g.drawImageAt(background, x, y);

 // free dynamically allocated memory:
 delete   background;
 delete[] pixelData;
}


//----------------------------------------------------------------------------
//
void MetallicLookAndFeel::fillRectWithMetallicGradient2(juce::Graphics &g, 
                                                    int x, 
                                                    int y, 
                                                    int w, 
                                                    int h)
{
 ColourGradient grad;

 grad = ColourGradient(Colour((uint8)255,(uint8)255,(uint8)255,(uint8)255), 
                       (float) x,     (float) y, 
                       Colour((uint8)255,(uint8)255,(uint8)255,(uint8)255), 
                       (float) (x+w), (float) (y+h), false);

 grad.addColour(0.5, Colour((uint8)220,(uint8)220,(uint8)220,(uint8)255) );
 GradientBrush  gBrush(grad);

 g.setBrush(&gBrush);

 g.fillRect(x, y, w, h);


 grad = ColourGradient(Colour((uint8)200,(uint8)200,(uint8)200,(uint8)90), 
                       (float) x,     (float) (y+h), 
                       Colour((uint8)200,(uint8)200,(uint8)200,(uint8)90), 
                       (float) (x+w), (float) y , false);

 grad.addColour(0.5, Colour((uint8)255,(uint8)255,(uint8)255,(uint8)90) );

 GradientBrush  gBrush2(grad);

 g.setBrush(&gBrush2);

 g.fillRect(x, y, w, h);

}

//----------------------------------------------------------------------------
//
void MetallicLookAndFeel::fillEllipseWithMetallicGradient(juce::Graphics &g, 
                                                    int x, 
                                                    int y, 
                                                    int w, 
                                                    int h)
{
 ColourGradient grad;

 grad = ColourGradient(Colour((uint8)255,(uint8)255,(uint8)255,(uint8)255), 
                       (float) x,     (float) y, 
                       Colour((uint8)255,(uint8)255,(uint8)255,(uint8)255), 
                       (float) (x+w), (float) (y+h) , false);

 grad.addColour(0.5, Colour((uint8)220,(uint8)220,(uint8)220,(uint8)255) );
 GradientBrush  gBrush(grad);

 g.setBrush(&gBrush);

 g.fillEllipse((float) x, (float) y, (float) w, (float) h);


 grad = ColourGradient(Colour((uint8)200,(uint8)200,(uint8)200,(uint8)90), 
                       (float) x,     (float) (y+h), 
                       Colour((uint8)200,(uint8)200,(uint8)200,(uint8)90), 
                       (float) (x+w), (float) y , false);

 grad.addColour(0.5, Colour((uint8)255,(uint8)255,(uint8)255,(uint8)90) );

 GradientBrush  gBrush2(grad);

 g.setBrush(&gBrush2);

 g.fillEllipse((float) x, (float) y, (float) w, (float) h);
}