#ifndef __JUCE_METALLICLOOKANDFEEL_JUCEHEADER__
#define __JUCE_METALLICLOOKANDFEEL_JUCEHEADER__

#include <juce.h>

#include "SliderWithoutBoxes.h"

/*
#include "MetallicButton.h"
#include "MetallicCloseButton.h"
#include "MetallicMaximiseButton.h"
#include "MetallicMinimiseButton.h"
*/


/*
#include <System.h>
using namespace System; // for RTTI
*/

/*
#include "MoreMath.h"
using namespace MoreMath;
*/



class MetallicLookAndFeel : public LookAndFeel
{
public:
 /** Contructor. */
 MetallicLookAndFeel(void);

 /** Destructor */
 ~MetallicLookAndFeel(void);

 /** Overrides the createDocumentWindowButton method. */
 //Button* createDocumentWindowButton (int buttonType);

 /** Overrides the drawComboBox method. */
 /*
 void drawComboBox(Graphics& g, int width, int height,
                   const bool isButtonDown,
                   int buttonX, int buttonY,
                   int buttonW, int buttonH,
                    ComboBox& box);
 */

 /** Overrides the drawLinearSlider method. */
virtual void drawLinearSlider (Graphics& g,
                               int x, int y,
                               int width, int height,
                               float sliderPos,
                               float minSliderPos,
                               float maxSliderPos,
                               const Slider::SliderStyle style,
                               Slider& slider);
 /*
 virtual void drawLinearSlider(juce::Graphics&           g, 
                               int                       x, 
                               int                       y, 
                               int                       width, 
                               int                       height,
                               float                     sliderPos,
                               const Slider::SliderStyle style,  
                               juce::Slider&             slider); //for the old JUCE */




 /** Overrides the drawRotaraySlider method. */
 virtual void drawRotarySlider(juce::Graphics& g, 
                               int             x, 
                               int             y, 
                               int             width, 
                               int             height,
                               float           sliderPos,
                               const float     rotaryStartAngle,
                               const float     rotaryEndAngle,
                               juce::Slider&   slider);

 /** Overrides the drawToggleButton method. */
 virtual void drawToggleButton(juce::Graphics &g,
                               juce::ToggleButton &button,
                               bool isMouseOverButton,
                               bool isButtonDown);


 /** Sets up the white-values for the gradient background drawing. The 
     float-parameters  are the white values for the rsepctive corners. */
 static void setWhiteValues(float newTopLeftWhiteValue, 
                             float newTopRightWhiteValue,
                             float newBottomLeftWhiteValue,
                             float newBottomRightWhiteValue);

 /** Fills a rectangle with a metallic color gradient. */
 static void fillRectWithMetallicGradient(juce::Graphics &g,
                                          int x,
                                          int y,
                                          int w,
                                          int h);

 /** Fills a rectangle with a metallic color gradient (faster). */
 static void fillRectWithMetallicGradient2(juce::Graphics &g,
                                           int x,
                                           int y,
                                           int w,
                                           int h);

 /** Fills an ellipse with a metallic color gradient. */
 static void fillEllipseWithMetallicGradient(juce::Graphics &g,
                                             int x,
                                             int y,
                                             int w,
                                             int h);


protected:
 static float topLeftWhiteValue;
 static float topRightWhiteValue;
 static float bottomLeftWhiteValue;
 static float bottomRightWhiteValue;
};

#endif   // __JUCE_METALLICLOOKANDFEEL_JUCEHEADER__
