/**

This is a class fo representing Points in 3-dimensional space.

*/


#ifndef __JUCE_POINT3D_JUCEHEADER__
#define __JUCE_POINT3D_JUCEHEADER__

#include <math.h>

class Point3D	
{

public:

 Point3D(double initX = 0.0, double initY = 0.0, double initZ = 0.0);
 /**< Standard constructor. Initializes coordinates with the passed values. */

 virtual ~Point3D();
 /**< Destructor. */

 virtual double getX();
 /**< Returns the x-coordinate of the point. */

 virtual void setX(double newX);
 /**< Sets the x-coordinate of the point. */

 virtual double getY();
 /**< Returns the y-coordinate of the point. */

 virtual void setY(double newY);
 /**< Sets the y-coordinate of the point. */

 virtual double getZ();
 /**< Returns the z-coordinate of the point. */

 virtual void setZ(double newZ);
 /**< Sets the z-coordinate of the point. */

 virtual void setXYZ(double newX, double newY, double newZ);
 /**< Sets all three coordinates of the point. */

 virtual double getDistanceToOrigin();
 /**< Returns the distance of the point to the origin. */

protected:

 double x, y, z;

};

#endif	// __JUCE_POINT3D_JUCEHEADER__
