#include "SliderWithoutBoxes.h"

SliderWithoutBoxes::SliderWithoutBoxes() :	Slider( T("SliderWithoutBoxes") )
{
 setSize(32, 32);
 setSliderStyle(RotaryVerticalDrag);
 setTextBoxStyle(NoTextBox, false, 1, 1);
 hideTextBox(false);  // the textbox inherited from the slider base-class
                      // should not be visible 

 isExponentiallyScaled = false;
 isUpDownDragger       = false;
}

SliderWithoutBoxes::~SliderWithoutBoxes(void)
{

}

double SliderWithoutBoxes::proportionOfLengthToValue(double proportion)
{
 double min, max, skew;
 min  = getMinimum();
 max  = getMaximum();
 skew = 1.0; // skew (from the slider base-class) not accessible yet

 if(isExponentiallyScaled && min>0.0)
 {
  return min * exp( proportion*(log(max)-log(min)) );
 }

 else if(skew != 1.0 && proportion > 0.0) // to support the "skew" 
                                                // from the base-class
 {
  proportion = exp (log (proportion) / skew);
 }
 return min + proportion*(max-min);
}

double SliderWithoutBoxes::valueToProportionOfLength(double value)
{
 double min, max, skew;
 min  = getMinimum();
 max  = getMaximum();
 skew = 1.0; // skew (from the slider base-class) not accessible yet

 if(isExponentiallyScaled && min>0.0)
 {
  return log(value/min) / (log(max)-log(min));
 }
 else
 {
  const double n = (value - min) / (max - min);
  return skew == 1.0 ? n : pow (n, skew);
 }
}

