#include <juce.h>

#ifndef __JUCE_SLIDERWITHOUTBOXES_JUCEHEADER__
#define __JUCE_SLIDERWITHOUTBOXES_JUCEHEADER__

class SliderWithoutBoxes	:	public Slider
{
public:

 SliderWithoutBoxes();   /**< Constructor. */
 ~SliderWithoutBoxes();  /**< Destructor. */

 /** Sets an indicator flag, that this slider should be drawn compactly as an
     up/down drag-arrow pair. */
 virtual void setUpDownDragger(bool shouldBeUpDownDragger = true)
 { isUpDownDragger = shouldBeUpDownDragger; }

 /** Makes the mapping bewtween the minimum and maximum value expoential.
     The minimum should be > 0, otherwise a log of zero or log of negative
      number will occur. */
 virtual void setExponentialMode(bool shouldBeExponentiallyScaled = true)
 { isExponentiallyScaled = shouldBeExponentiallyScaled; }

 /** maps the slider position (expressed as proportion of its length) to the
     actual value. */  
 virtual double proportionOfLengthToValue(double proportion);

 /** maps the slider value to a value which represents the slider position as 
     a proportion of it's length (that is: a value between 0 and 1). */
 virtual double valueToProportionOfLength(double value);

 bool isUpDownDragger;

protected:

 bool isExponentiallyScaled;
};

#endif   // __JUCE_SLIDERWITHOUTBOXES_JUCEHEADER__